unit UPrinc;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IniFiles;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    BuSair: TButton;
    Button2: TButton;
    Button4: TButton;
    procedure ComboBox1Exit(Sender: TObject);
    procedure BuSairClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    procedure GravarLista(vCombo: TComboBox);
    procedure CarregarComboBox(vCombo: TComboBox);
    procedure LerSecao(vTipo: SHORT);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.GravarLista(vCombo: TComboBox);
var
  vMeuIni : TIniFile;
  I : SHORT; //s por questo de economia
begin
   vMeuIni := TIniFile.Create('ListasDeString.ini');
  try

   if vMeuIni.SectionExists('USUARIOS') then
      vMeuIni.EraseSection('USUARIOS');

   For I := 0 to Pred(vCombo.Items.Count) do
   begin
     vMeuIni.WriteString('USUARIOS','NOME_' + IntToStr(I),vCombo.Items.Strings[I]);
   end;
  finally
   vMeuIni.Free;
  end;
end;

procedure TForm1.CarregarComboBox(vCombo:TComboBox);
var
  vMeuIni : TIniFile;
  vLista  : TStringList;
  I       : SHORT;
  Excluir : String;
begin
   vMeuIni := TIniFile.Create('ListasDeString.ini');
   vLista := TStringList.Create;
   ComboBox1.Clear; //Exclui todos os itens - se houverem  claro
  try
    if vMeuIni.SectionExists('USUARIOS') then
    begin
     vMeuIni.ReadSectionValues('USUARIOS',vLista);

     For I := 0 to Pred(vLista.Count) do
     begin
       if (Pos('=', vLista.Strings[I]) > 0) then
       begin
         Excluir := vLista.Strings[I];
         Delete(Excluir,1,Pos('=', Excluir));
         ComboBox1.Items.Add(Excluir);
       end;
     end;
     ComboBox1.ItemIndex := 0;
    end;
  finally
   vMeuIni.Free;
   vLista.Free;
  end;
end;

procedure TForm1.LerSecao(vTipo: SHORT);
var
  vMeuIni : TIniFile;
  vLista  : TStringList;
begin
   vMeuIni := TIniFile.Create('ListasDeString.ini');
   vLista := TStringList.Create;
  try
    if vMeuIni.SectionExists('USUARIOS') then
    begin
     Case vTipo of
     0 : vMeuIni.ReadSection('USUARIOS',vLista);
     1 : vMeuIni.ReadSectionValues('USUARIOS',vLista);
     end;
     ShowMessage(vLista.Text);
    end else ShowMessage('A Seo "Usurios ainda no existe"'); 
  finally
   vMeuIni.Free;
   vLista.Free;
  end;
end;

procedure TForm1.ComboBox1Exit(Sender: TObject);
begin
  if ComboBox1.Items.IndexOf(ComboBox1.Text) = -1 then
     ComboBox1.Items.Add(ComboBox1.Text);

  {A funo IndexOf retorna o valor -1 se a String no estiver armazenada
   no ComboBox1. Qualquer valor superior a -1  sinal de que a String j
   est armazenada e o valor de retorno  a posio da String dentro do
   ComboBox.

   A leitura seria mais ou menos algo assim: Procure no ComboBox o texto
   digitado no prprio ComboBox, se no achar o texto, insere ele na lista;
   se achar o texto no faz nada.}
end;

procedure TForm1.BuSairClick(Sender: TObject);
begin
  if MessageDlg('Voc deseja salvar os nomes inseridos no ComboBox?',
     mtConfirmation,[mbYes,mbNo], 0) = mrYes then
     GravarLista(ComboBox1);

  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  LerSecao(0);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
LerSecao(1);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  CarregarComboBox(ComboBox1);
end;

end.
